; GESTFILE.ASM
;
;.............. fonctions de gestion de files d'attentes ...........
;
;			       EQUALIZER
;
;		     Noyau multitache. Chapitre I.
;
;...................................................................

PAGE 60,132
TITLE GESTION DE FILES D'ATTENTE

.MODEL SMALL,OS_DOS
.286

INCLUDE descript.inc	; dfinition du type DESCRIPTEUR
INCLUDE Etats.inc

.CODE


;
; Fonction d'insertion dans une liste chaine
;
; (DS:BX)   : Descripteur  inserer
; (DS:SI)   : Cellule de garde de la liste
;

insere PROC NEAR
    assume ds:@data
    push    si
    call    recherche	    ; recherche du rang o inserer
    call    InsereItem	    ; insre  ce rang
    pop     si
    ret
insere ENDP


;
; Fonction de recherche dans une liste chaine
;
; entre :
; (DS:BX)   : Descripteur  inserer
; (DS:SI)   : Cellule de garde de la liste
;
; sortie :
; (DS:SI)   : Position d'insertion
;
recherche PROC NEAR
    assume ds:@data
    push    ax
    mov     al,(DESCRIPTEUR PTR [bx]).priorite
BoucleRecherche:
    mov     si,(DESCRIPTEUR PTR [si]).suivant	; On prend le suivant dans la liste
    cmp     al,(DESCRIPTEUR PTR [si]).priorite	; priorit >= ?
    jae	   BoucleRecherche			; oui ! on boucle.
    pop     ax
    ret
recherche ENDP



;
; Fonction de d'insertion dans une liste chaine
;
; entre :
; (DS:BX)   : Descripteur  inserer
; (DS:SI)   : Position d'insertion
;
InsereItem PROC NEAR
    assume ds:@data
    push    si
    mov     si,(DESCRIPTEUR PTR [si]).precedent ; si = prcdent
    mov     (DESCRIPTEUR PTR [si]).suivant,bx	; il pointe sur le nouvel lment
    mov     (DESCRIPTEUR PTR [bx]).precedent,si ; et est point par celui-ci
    pop     si
    mov     (DESCRIPTEUR PTR [bx]).suivant,si	; le nouvel lment pointe sur 'si'
    mov     (DESCRIPTEUR PTR [si]).precedent,bx ; qui  pour prcdent 'bx'
    ret
InsereItem ENDP


;
;   fonction dterminant si la file est vide
;
;   entre : (DS:SI) = cellule de garde de la liste
;
;   rsultat :	ZF = 0	 si la liste n'est pas vide
;		ZF = 1	 si la liste est vide
;
FileVide PROC NEAR
    assume ds:@data
    cmp     si,(DESCRIPTEUR PTR [si]).precedent ; si pointe sur lui-mme ?
    ret
FileVide ENDP

;
;   fonction d'initiation de la file
;
;   entre : (DS:SI) = cellule de garde de la liste
;
InitVide PROC NEAR
    assume ds:@data
    mov     (DESCRIPTEUR PTR [si]).suivant,si	; on fait pointer la cellule
    mov     (DESCRIPTEUR PTR [si]).precedent,si ; de garde sur elle mme
    mov     (DESCRIPTEUR PTR [si]).Etat,OCCUPE
    mov     (DESCRIPTEUR PTR [si]).priorite,INFINI

    ret
InitVide ENDP


;
;   fonction d'extraction
;
; Entre : (DS:BX) cellule  extraire
;
extrait PROC NEAR
    assume ds:@data
    push    bx
    push    si
    mov     si,(DESCRIPTEUR PTR [bx]).precedent ; on fait pointer la cellule
    mov     bx,(DESCRIPTEUR PTR [bx]).suivant	; prcdente sur la cellule
    mov     (DESCRIPTEUR PTR [si]).suivant,bx	; suivante et vice versa.
    mov     (DESCRIPTEUR PTR [bx]).precedent,si
    pop     si
    pop     bx
    ret
extrait ENDP

;
;   fonction qui extrait la premire cellule de la liste
;
; entre :
; (DS:SI) Cellule de garde
;
; sortie :
; (DS:BX) cellule extraite
;
PremierDeListe PROC NEAR
    assume ds:@data
    mov     bx,(DESCRIPTEUR PTR [si]).suivant
    call    extrait
    ret
PremierDeListe ENDP

;
;   fonction qui extrait la dernire cellule de la liste
;
; entre :
; (DS:SI) Cellule de garde
;
; sortie :
; (DS:BX) cellule extraite
;
DernierDeListe PROC NEAR
    assume ds:@data
    mov     bx,(DESCRIPTEUR PTR [si]).precedent
    call    extrait
    ret
DernierDeListe ENDP


;
;   Procedure EMPILER
;
;   Entre : (DS:SI) Cellule de garde
;	     (DS:BX) Cellule  empiler
;

empiler PROC NEAR
    assume ds:@data
    push    si
    mov     si,(DESCRIPTEUR PTR [si]).suivant	; On insre en premire
    call    InsereItem				; position
    pop     si
    ret
empiler ENDP



;
;   Procedure DEPILER ( Last In First Out )
;
;   Entre : (DS:SI) Cellule de garde
;
;   Sortie : (DS:BX) Cellule dpile
;
depiler PROC NEAR
    assume ds:@data
    mov     bx,(DESCRIPTEUR PTR [si]).suivant	; On dpile la premire
    call    extrait				; cellule de la file.
    ret
depiler ENDP

END
